C# Class SolidworksAddinFramework.Geometry.CurveExtension

Afficher le fichier Open project: Weingartner/SolidworksAddinFramework

Méthodes publiques

Méthode Description
ApplyTransform ( this body, Matrix4x4 t ) : void
ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
CurveBoundsDoubleArray ( this curve ) : double[]
DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
Domain ( this curve ) : double[]

Return the domain of the curve. ie the [startParam, endParam]

EndPoint ( this curve, int derivatives ) : List
EndPoint ( this curve ) : System.Vector3
FindMinimumRadius ( this curve ) : MinimumRadiusResult
GetCurveTs ( this edge ) : ICurve
GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List

Approximation. Be carefull

GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
Length ( this curve ) : double

Return the length of the curve between the start and end parameters.

PointAt ( this curve, double t, int derivatives ) : List

Return the point at parameter value t on the curve.

PointAt ( this curve, double t ) : System.Vector3
PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
PointAtDistanceFrom ( this c, double t0, double distance ) : double

Should solve

PointParamAt ( this curve, double t ) : PointParam
PointTangentAt ( this c, double t ) : PointDirection3
ReverseEvaluate ( this curve, System.Vector3 p ) : double
StartPoint ( this curve, int derivatives ) : List
StartPoint ( this curve ) : System.Vector3

Private Methods

Méthode Description
GetTessPotsAsVector3 ( ICurve curve, double chordTol, double lengthTol, double startPt, double midPt ) : IEnumerable
MakeEdge ( IList edge ) : Edge3

Method Details

ApplyTransform() public static méthode

public static ApplyTransform ( this body, Matrix4x4 t ) : void
body this
t Matrix4x4
Résultat void

ClosestDistanceBetweenTwoCurves() public static méthode

public static ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
m IMathUtility
curve0 ICurve
curve1 ICurve
Résultat EdgeDistance

ClosestPointOn() public static méthode

public static ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
curve this
v System.Vector3
Résultat PointParam

ClosestPointOn() public static méthode

public static ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
curve this
x double
y double
z double
Résultat PointParam

ClosestPointTangentOn() public static méthode

public static ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
curve this
v System.Vector3
Résultat PointDirection3

ClosestPointToRay() public static méthode

public static ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
curve this
ray PointDirection3
tol double
Résultat PointParamWithRayProjection

CreateTrimmedCurve() public static méthode

public static CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
curve this
t0 double
t1 double
Résultat ICurve

CurveBoundsDoubleArray() public static méthode

public static CurveBoundsDoubleArray ( this curve ) : double[]
curve this
Résultat double[]

DisplayUndoable() public static méthode

public static DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
curve this
doc IModelDoc2
color Color
thickness double
chordTol double
lengthTol double
layer int
Résultat IDisposable

DisplayUndoable() public static méthode

public static DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
line this
doc IModelDoc2
color Color
thickness double
layer int
Résultat IDisposable

Domain() public static méthode

Return the domain of the curve. ie the [startParam, endParam]
public static Domain ( this curve ) : double[]
curve this
Résultat double[]

EndPoint() public static méthode

public static EndPoint ( this curve, int derivatives ) : List
curve this
derivatives int
Résultat List

EndPoint() public static méthode

public static EndPoint ( this curve ) : System.Vector3
curve this
Résultat System.Vector3

FindMinimumRadius() public static méthode

public static FindMinimumRadius ( this curve ) : MinimumRadiusResult
curve this
Résultat MinimumRadiusResult

GetCurveTs() public static méthode

public static GetCurveTs ( this edge ) : ICurve
edge this
Résultat ICurve

GetPlanePoints() public static méthode

public static GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
curve this
position double
pNormal System.Vector3
pCurve System.Vector3
pAxis System.Vector3
Résultat void

GetPointsByLength() public static méthode

Approximation. Be carefull
public static GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List
curve this
pointDistance double
flankHelixDomain AForge.DoubleRange
Résultat List

GetTessPoints() public static méthode

public static GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
curve this
chordTol double
lengthTol double
domain RangeDouble
Résultat System.Vector3[]

Length() public static méthode

Return the length of the curve between the start and end parameters.
public static Length ( this curve ) : double
curve this
Résultat double

PointAt() public static méthode

Return the point at parameter value t on the curve.
public static PointAt ( this curve, double t, int derivatives ) : List
curve this
t double
derivatives int
Résultat List

PointAt() public static méthode

public static PointAt ( this curve, double t ) : System.Vector3
curve this
t double
Résultat System.Vector3

PointAtDistanceFrom() public static méthode

public static PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
c this
p0 System.Vector3
distance double
Résultat double

PointAtDistanceFrom() public static méthode

Should solve
public static PointAtDistanceFrom ( this c, double t0, double distance ) : double
c this
t0 double
distance double
Résultat double

PointParamAt() public static méthode

public static PointParamAt ( this curve, double t ) : PointParam
curve this
t double
Résultat PointParam

PointTangentAt() public static méthode

public static PointTangentAt ( this c, double t ) : PointDirection3
c this
t double
Résultat PointDirection3

ReverseEvaluate() public static méthode

public static ReverseEvaluate ( this curve, System.Vector3 p ) : double
curve this
p System.Vector3
Résultat double

StartPoint() public static méthode

public static StartPoint ( this curve, int derivatives ) : List
curve this
derivatives int
Résultat List

StartPoint() public static méthode

public static StartPoint ( this curve ) : System.Vector3
curve this
Résultat System.Vector3